# Generated by Django 3.2.16 on 2022-11-15 16:10

import django.db.models.deletion
import django.utils.timezone
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("authentication", "0001_initial"),
        ("members", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="Group",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=256)),
                (
                    "kind",
                    models.CharField(
                        choices=[
                            ("committee", "committee"),
                            ("group", "group"),
                            ("SOCIETY", "society"),
                        ],
                        default="committee",
                        max_length=9,
                    ),
                ),
                ("since", models.DateField(default=django.utils.timezone.now)),
                ("until", models.DateField(blank=True, null=True)),
                (
                    "auth_groups",
                    models.ManyToManyField(blank=True, to="authentication.AuthGroup"),
                ),
            ],
        ),
        migrations.CreateModel(
            name="GroupCategory",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("title", models.CharField(max_length=256)),
            ],
        ),
        migrations.CreateModel(
            name="GroupMembership",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("since", models.DateField(default=django.utils.timezone.now)),
                ("until", models.DateField(blank=True, null=True)),
                (
                    "contact",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="members.contact",
                    ),
                ),
                (
                    "group",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="groups.group"
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="group",
            name="categories",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                to="groups.groupcategory",
            ),
        ),
        migrations.AddField(
            model_name="group",
            name="members",
            field=models.ManyToManyField(
                through="groups.GroupMembership", to="members.Contact"
            ),
        ),
    ]
